/*---------------------------------------------------
                  GADJINF(c; S,N,s,n)

Get Adjacency info.

Input:
   c  is a cell.

Output:
   S  is the adjacency info.
   N  is the total multiplicity info.
   s  is the bottom signature.
   n  is the number of projection factors.
----------------------------------------------------*/
#include "saclib.h"
#include "qepcad.h"

void GADJINF(c,S_,N_,s_,n_)
       Word c;
       Word *S_, *N_, *s_, *n_;
{
       Word S,N,s,n,C,C1,C2,S1,S11,S12,S13,M,M1,p,m,i;

Step1: /* Compute s. */
       C = LELTI(c,CHILD);
       ADV(C,&C1,&C);
       s = FIRST(LELTI(C1,SIGNPF));
       n = LENGTH(s);
       
Step2: /* Compute S and N. */
       S = NIL;
       N = NIL;
       for (i=1; i<=n; i++)
          N = COMP(0,N);
       while (C != NIL)
         {
         ADV2(C,&C1,&C2,&C);
         S13 = FIRST(LELTI(C2,SIGNPF));
         S12 = LELTI(C1,MULSUB);
         S11 = 0;
         M = S12;
         while (M != NIL)
           {
           ADV(M,&M1,&M);
           FIRST2(M1,&p,&m);
           SLELTI(N,p,LELTI(N,p)+m);
           S11 += m;
           }
         S1 = LIST3(S11,S12,S13);
         S = COMP(S1,S);
         }
       S = INV(S);

Return: /* Return. */
       *s_ = s;
       *n_ = n;
       *S_ = S;
       *N_ = N;
       return;
}


