/*======================================================================
                      INITSTAT()

Initialize Statistics.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void INITSTAT()
{
       Word i;
       /* hide i; */

Step1: /* Statistics on Normalization Phase. */
       TMNORMQFF = 0;

Step2: /* Statistics on Projection Phase. */
       for (i = 1; i <= MNV; i++) TMPROJECT[i] = 0;
       for (i = 1; i <= MNV; i++) TMPROJ[i] = 0;
       for (i = 1; i <= MNV; i++) TMIPFZT[i] = 0;
       for (i = 1; i <= MNV; i++) TMIPLFAC[i] = 0;
       for (i = 1; i <= MNV; i++) TMAPPEND[i] = 0;
       for (i = 1; i <= MNV; i++) NMNIP[i] = 0;
       for (i = 1; i <= MNV; i++) NMPF[i] = 0;
       for (i = 1; i <= MNV; i++) NMPJ[i] = 0;

Step3: /* Statistics on Truth Invariant CAD Construction Phase. */
       for (i = 1; i <= MNV; i++) TMTICAD[i] = 0;
       for (i = 1; i <= MNV; i++) TMCHOOSE[i] = 0;
       for (i = 1; i <= MNV; i++) TMCONVERT[i] = 0;
       for (i = 1; i <= MNV; i++) TMTCN[i] = 0;
       for (i = 1; i <= MNV; i++) TMNORMAL[i] = 0;
       for (i = 1; i <= MNV; i++) TMSIMPLE[i] = 0;
       for (i = 1; i <= MNV; i++) TMCONSTRUCT[i] = 0;
       for (i = 1; i <= MNV; i++) TMSUBST[i] = 0;
       for (i = 1; i <= MNV; i++) TMAFUPLM[i] = 0;
       for (i = 1; i <= MNV; i++) TMAFCSBM[i] = 0;
       for (i = 1; i <= MNV; i++) TMAFPBRI[i] = 0;
       for (i = 1; i <= MNV; i++) TMSIGNP[i] = 0;
       for (i = 1; i <= MNV; i++) TMEC[i] = 0;
       for (i = 1; i <= MNV; i++) TMRCFAFC[i] = 0;
       for (i = 1; i <= MNV; i++) TMSUBSTR[i] = 0;
       for (i = 1; i <= MNV; i++) TMIPLSRP[i] = 0;
       for (i = 1; i <= MNV; i++) TMIPFSBM[i] = 0;
       for (i = 1; i <= MNV; i++) TMIPLRRI[i] = 0;
       for (i = 1; i <= MNV; i++) TMECR[i] = 0;
       for (i = 1; i <= MNV; i++) TMSIGNPR[i] = 0;
       for (i = 1; i <= MNV; i++) TMEVALUATE[i] = 0;
       for (i = 1; i <= MNV; i++) TMPROPAGATE[i] = 0;
       for (i = 1; i <= MNV; i++) TMAPEQC[i] = 0;
       for (i = 1; i <= MNV; i++) NMSTACK[i] = 0;
       for (i = 1; i <= MNV; i++) NMSTACKR[i] = 0;
       for (i = 1; i <= MNV; i++) NMCELL[i] = 0;
       for (i = 1; i <= MNV; i++) NMCONVERT[i] = 0;
       for (i = 1; i <= MNV; i++) NMTCONVERT[i] = 0;

Step4: /* Statistics on Solution Formula Construction Phase. */
       TMSOLUTION = 0;
       TMSIGTBL = 0;
       TMSIGINS = 0;
       TMMVLMASF = 0;
       TMGENIMP = 0;
       TMSELIMP = 0;
       NMFPF = 0;
       NMPRPT = 0;
       NMPRPF = 0;
       NMPRPC = 0;
       NMGENPRD = 0;
       NMGENIMP = 0;
       NMSELIMP = 0;
       NMATOM = 0;

Step5: /* Statistics on Databases. */
       TMDBMNG = 0;
       TMDBSAV = 0;
       goto Return;

Return: /* Prepare for return. */
       return;
}
