/*======================================================================
                        t <- COVERS(M,i,j,Nc)

Covers.

\Input
  \parm{M}  is an array of marks associated with the prime implicants
  \parm{Nc} is the length of an element of M.
  \parm{i}  is a row index.
  \parm{j}  is a row index.
           
\Output
  \parm{t}  is 1 if the row i covers the row j, 0 otherwise.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#define ALIVE      0
#define DEAD       1
#define ESSENTIAL  2

Word COVERS(M,i,j,Nc)
       MarksTable  M;
       Word i,j,Nc;
{
       Word t,k;

Step1: /* Check. */
       t = 1;
       for (k = 1; k <= Nc; k++) 
         {
         if (M[0][k] != ALIVE) continue;
         if ( (~(M[i][k])) & M[j][k] ) { t = 0; break; }
         }

Return: /* Prepare for return. */
       return (t);
}



