/*======================================================================
                      LENSIGTBL(c,f,L_t,L_f; Lp_t,Lp_f)

Length of Signature Tables.

\Input
  \parm{c}  is a cell of the final partial CAD.
  \parm{f}  is the number of the free variables.
  \parm{Lt} is the number of of signatures for propagation solution cells
            visited so far.
  \parm{Lf} is the number of of signatures for propagation non-solution cells
            visited so far.

\Ouput
  \parm{L't} is the number of signaturess for propagation solution cells
             after visiting the cells over $c$.
  \parm{L'f} is the number of signatures  for propagation non-solution cells
             after visiting the cells over $c$.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void SIGTBL(c,f,L_t,L_f, Lp_t_,Lp_f_)
       Word c,f,L_t,L_f, *Lp_t_,*Lp_f_;
{
       Word Lp_f,Lp_t,cb,cp,k;

Step1: /* At the $f$-space. */
       Lp_t = L_t; Lp_f = L_f;
       k = LELTI(c,LEVEL);
       if (k < f) goto Step2;
       if (LELTI(c,HOWTV) == BYPRP)
         {
         if (LELTI(c,TRUTH) == TRUE)
           Lp_t = Lp_t + 1;
         else
           Lp_f = Lp_f + 1;
         }
       goto Return;

Step2: /* Other cases. */
       cb = LELTI(c,CHILD);
       while (cb != NIL)
         {
         ADV(cb,&cp,&cb);
         SIGTBL(cp,f,Lp_t,Lp_f,&Lp_t,&Lp_f);
         }

Return: /* Prepare for return. */
       *Lp_t_ = Lp_t;
       *Lp_f_ = Lp_f;
       return;
}
