/*======================================================================
                      Tp <- SIGSUB(T,L,Lp)

Signature Subtraction.

\Input
  \parm{T} is an array of signatures.
  \parm{L} is the length of the array T.
  \parm{Lp} is the length of the output array Tp.
  
Output
  \parm{Tp} is the array of the unmarked signatures.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

RelOpsTable SIGSUB(T,L,Lp)
       Word L,Lp;
       RelOpsTable T;
{
       RelOpsTable Tp;
       Word i,j;

Step1: /* Allocate. */
       Tp = RELTALLOC(Lp);

Step2: /* Gather unmarked ones. */ 
       j = 0;
       for (i = 1; i <= L; i++)
         if (T[i][0] == 0)
           {
           j++;
           Tp[j] = T[i];
           }

Return: /* Prepare for return. */
       return(Tp);
}
