/*======================================================================
                      T <- STFSOP(H)

Signature Table From Sum-Of-Product.

\Input
  \parm{H} is a sum-of-product 
  
\Output
  \parm{T} is the list of distinct signatures corresponding to $H$.
  
\Side
  \parm{H} is modified.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word STFSOP(H)
       Word H;
{
       Word T,T1,T11;

Step1: /* Convert. */
       T = H;
       while (T != NIL)
         {
         ADV(T,&T1,&T);
         while (T1 != NIL)
           {
           T11 = FIRST(T1);
           switch (T11)
             {
             case GTOP: SFIRST(T1,POSITIVE); break;
             case LTOP: SFIRST(T1,NEGATIVE); break;
             case EQOP: SFIRST(T1,ZERO); break;
             case TAOP: SFIRST(T1,UNDET); break;
             }
           T1 = RED(T1);
           }
         }
       T = H;
       goto Return;

Return: /* Prepare for return. */
       return(T);
}
