/*=======================================================
                    qepcad.h                                        
========================================================*/
#ifndef QEPCAD_H
#define QEPCAD_H
#include <stdio.h>

/* ----------------------------------------*/
/*            Algorithms                   */
/* ----------------------------------------*/
extern Word ADJ2  P__((Word C));
extern Word ADJ2SL  P__((Word n, Word s, Word N, Word S, Word L));
extern void ADJINFOWR P__((void));
extern void AFCSBM   P__((Word M, Word A, Word *B_, Word *G_));
extern void AFCSBMDB   P__((Word M, Word Ps, Word *Bs_, Word *Es_));
extern void AFLWR   P__((Word M, Word I, Word N, Word a, Word A));
extern void AFMSBM   P__((Word M, Word A, Word B, 
			  Word *C_, Word *E_, Word *F_));
extern void AFPDWR   P__((Word r, Word A, Word V, Word N));
extern void AFWR   P__((Word A, Word a));
extern Word AFPNIPDB   P__((Word Mb, Word B));
extern Word AFUPFMRC P__((Word Q1,Word D1,Word C1,Word Q2,Word D2,Word C2));
extern Word AFUPGCDB  P__((Word M, Word A, Word B, Word *C_, Word *Ab_, Word *Bb_));
extern void AFUPLM   P__((Word M, Word A, Word *L_, Word *P_));
extern void AFUPRWR  P__((Word a, Word v, Word A, Word I));
extern Word AFUPSFNDB  P__((Word M, Word B, Word *t_, Word *Bt_, Word *F_));
extern void APEQC   P__((Word c, Word k, Word P));
extern Word APPEND   P__((Word P, Word k, Word R));
extern void APPENDEC  P__((Word P, Word k, Word R, Word *Ps_, Word *F_));
extern void ATOMFLWR   P__((Word N, Word V, Word A));
extern void ATOMFRDR   P__((Word V, Word *F_, Word *t_));
extern void ATOMFWR   P__((Word V, Word A));
extern Word CAPTURE   P__((Word P, Word M));
extern Word CATOMQFF   P__((Word F));
extern void CATTRNRDR   P__((Word *V_, Word *t_));
extern void CATTRNWR   P__((Word A));
extern Word CELLATTR   P__((Word c, Word A));
extern Word CELLCOMP   P__((Word c1, Word c2, Word S));
extern Word CELLDEG   P__((Word c));
extern Word CELLDIM   P__((Word c));
extern void CELLFIDX   P__((Word x, Word c, Word *cp_, Word *t_));
extern Word CELLSQ   P__((Word c, Word k, Word h, Word j));
extern void CELLRDR   P__((Word D, Word *c_, Word *t_));
extern void CELLWR   P__((Word c));
extern void CELLSWR   P__((Word c));
extern void CHCELL   P__((Word cs, Word *c_, Word *t_));
extern Word CHKCONS  P__(( Word n, Word s, Word N, Word S, Word L, Word a, 
			  Word *sp_, Word *Np_, Word *Sp_, Word *Lp_));
extern void CHOOSE   P__((Word D, Word *t_, Word *c_));
extern void CHSCN   P__((Word M, Word I, Word N, Word J, Word t, Word S, 
			 Word *S1_, Word *K1_));
extern void CLEANUPSYS   P__((void));
extern Word COMMNT   P__((void));
extern void COMMNTRD   P__((void));
extern void CONSTRUCT   P__((Word c, Word k, Word f, Word Ps, Word As));
extern Word CONVERT   P__((Word s, Word k));
extern void CONWR   P__((Word V, Word C));
extern Word CVCOMP   P__((Word c1, Word c2));
extern void DBADD   P__((Word D, Word K, Word C, Word *Dp_));
extern Word DBSRCH   P__((Word D, Word K));
extern void DBSTATWR   P__((Word D, Word M));
extern Word DESCENDANT  P__((Word c, Word x, Word kp));
extern void DESIREDRDR   P__((Word *F_, Word *t_));
extern void DESIREDWR   P__((Word C));
extern void DIELOC   P__((void));
extern Word DIFTMUL  P__((Word N1, Word N2));
extern void DISCONWR   P__((Word V, Word F));
extern Word DMAFUPNR P__((Word p,Word M,Word A,Word B));
extern void DNFWR   P__((Word V, Word F));
extern void DNFLPWR  P__((Word N, Word V, Word F));
extern void DNFLWR   P__((Word N, Word V, Word F));
extern Word DSCOMP   P__((Word c1, Word c2));
extern void DSTATWR   P__((void));
extern void EC   P__((Word c, Word L, Word E, Word Bs));
extern void EC1   P__((Word c, Word L, Word Bs));
extern Word ECLEVEL  P__((Word L));
extern void ECR   P__((Word c, Word L, Word E, Word Bs));
extern void ESPIWR   P__((Word T1, Word T0));
extern Word ESPORD  P__((void));
extern Word ESPRESSO P__((Word T_t, Word T_f));
extern void EVALUATE   P__((Word c, Word k, Word F, Word A));
extern Word EXPAFEQ   P__((Word L));
extern Word EXPAFGT   P__((Word L));
extern Word EXPAFGTS   P__((Word L));
extern Word EXPAFLT   P__((Word L));
extern Word EXPAFLTS   P__((Word L));
extern Word EXTRACT   P__((Word r, Word F));
extern void EXTRACTS   P__((Word F, Word A, Word *Ap_));
extern void FGWRITE   P__((Word A, Word n));
extern void FILINE   P__((void));
extern void FILLIN   P__((Word n, Word vs, Word S_r, Word S_s, 
			  Word R_c, Word R_s, Word *v_));
extern void FIRSTCOMB   P__((Word n, Word r, Word *R_));
extern void FIRSTLEXI   P__((Word l, Word *R_));
extern void FIRSTPRD   P__((Word n, Word *v_, Word *S_r_, Word *S_s_, 
			    Word *R_c_, Word *R_s_));
extern void FNDTS   P__((Word M, Word N, Word *t_, Word *S_, Word *U_));
extern void FNDTSDB   P__((Word Mb, Word Nb, Word *t_, Word *S_, Word *U_));
extern void FPSIGTBL   P__((Word c, Word f, Word T_t, Word T_f, 
			    Word *Tp_t_, Word *Tp_f_));
extern void FREADR   P__((Word V, Word f, Word *Fs_, Word *t_));
extern void FSIGTBL   P__((Word c, Word f, Word T_t, Word T_f, 
			   Word *Tp_t_, Word *Tp_f_));
extern void FWRITE   P__((Word V, Word Fs));
extern void GADJINF  P__((Word c, Word *S_, Word *Ns_, Word *s_, Word *n_));
extern Word GENPIMP   P__((Word H_t, Word H_f));
extern Word GETCID   P__((Word P, Word W));
extern void GETRP   P__((Word S1, Word t, Word U, Word *Ms_, Word *Ns_));
extern void GETRPDB   P__((Word S1, Word t, Word U, Word *Ms_, Word *Ns_));
extern Word GETWORD   P__((void));
extern void GFPCSTAT   P__((Word c, Word *p1_, Word *p0_, 
			    Word *t1_, Word *t0_, Word *l_));
extern void GREADR   P__((Word *a_, Word *t_));
extern Word GROUPSAMEPJ  P__((Word r, Word J));
extern void HELPFRD   P__((void));
extern void HELPWR   P__((Word I));
extern void INITCTRL   P__((void));
extern void INITDB   P__((void));
extern void INITIO   P__((void));
extern Word INITPCAD   P__((void));
extern void INITSTAT   P__((void));
extern void INITSYS   P__((void));
extern void INPUTRD   P__((Word *Fs_, Word *V_));
extern Word INTERACT   P__((void));
extern Word IPDSCRPRS  P__((Word r, Word A));
extern Word IPDSCRQE  P__((Word r,Word A));
extern void IPFACDB   P__((Word r, Word P, Word *s_, Word *c_, Word *L_));
extern void IPFSBM   P__((Word r, Word A, Word *B_, Word *G_));
extern Word IPFZT   P__((Word r, Word A));
extern Word IPFZT1   P__((Word r, Word A));
extern void IPLDWR   P__((Word V, Word A));
extern Word IPLFAC   P__((Word k, Word J));
extern void IPLLDWR   P__((Word V, Word A));
extern void IPLSRP   P__((Word A, Word *s_, Word *P_));
extern Word IPPSCT   P__((Word r, Word A, Word B, Word S));
extern Word IPRESPRS  P__((Word r, Word A, Word B));
extern Word IPRESQE  P__((Word r,Word A,Word B));
extern Word ISATOMF   P__((Word F));
extern Word ISDESIRED   P__((Word c, Word C));
extern Word ISNULL   P__((Word L));
extern Word ISPRIMIT   P__((Word s));
extern void IUPRWR   P__((Word v, Word A, Word I));
extern Word IXCOMP   P__((Word c1, Word c2));
extern void LABELWR   P__((Word N, Word I));
extern Word LCM  P__((Word L, Word M));
extern void LGOPRDR   P__((Word *p_, Word *t_));
extern void LGOPWR   P__((Word p));
extern Word LOAR  P__((Word k, Word Q, Word F));
extern Word LUNION  P__((Word L1, Word L2));
extern Word LVCOMP   P__((Word c1, Word c2));
extern Word MAFDIF P__((Word p,Word a,Word b));
extern Word MAFHOM P__((Word p,Word M,Word a));
extern Word MAFINV P__((Word p,Word M,Word a));
extern Word MAFPROD P__((Word p,Word M,Word a,Word b));
extern Word MAFUPDIF P__((Word p,Word A,Word B));
extern Word MAFUPEPROD P__((Word p,Word M,Word a,Word A));
extern Word MAFUPGCD P__((Word p,Word M,Word A,Word B));
extern Word MATCHWORD   P__((Word A, Word B));
extern Word MBPROD   P__((Word A, Word B));
extern Word MCELL   P__((Word a1, Word a2, Word a3, Word a4, Word a5, 
			 Word a6, Word a7, Word a8, Word a9, Word a10));
extern Word MKMUL   P__((Word E, Word k));
extern Word MMFLR   P__((Word L));
extern void MODCR   P__((Word b, Word G, Word Ms, Word Ns, Word *bs_));
extern void MODCRDB   P__((Word b, Word S1, Word Ms, Word Ns, Word *b1_));
extern Word MPOLY   P__((Word a1, Word a2, Word a3, Word a4, Word a5));
extern Word MUPNR P__((Word p,Word A,Word B));
extern Word MVLMA   P__((Word H_t, Word H_f));
extern Word MVLMASF   P__((Word H_t, Word H_f));
extern Word NEGRLOP   P__((Word T));
extern void NEXTCELL   P__((Word D, Word c, Word *cp_, Word *t_));
extern void NEXTCOMB   P__((Word n, Word r, Word Rs, Word *R_, Word *q_));
extern void NEXTLEXI   P__((Word l, Word Rs, Word *R_, Word *q_));
extern void NEXTPRD   P__((Word n, Word vs, Word Ss_r, Word Ss_s, 
			   Word Rs_c, Word Rs_s, Word *v_, 
			   Word *S_r_, Word *S_s_, 
			   Word *R_c_, Word *R_s_, Word *q_));
extern Word NORMAF   P__((Word A));
extern Word NORMAFS   P__((Word Fh));
extern Word NORMAL   P__((Word s));
extern Word NORMQFF   P__((Word Fh));
extern Word NQFFAND   P__((Word F, Word G));
extern Word NQFFOR   P__((Word F, Word G));
extern void OUTPUTWR   P__((Word t, Word F_e, Word F_n, Word F_s, Word V));
extern void PARENTWR   P__((Word P));
extern void PCADWR   P__((Word c));
extern void PCADSWR   P__((Word c));
extern void PIMPTBLWR   P__((Word C, Word R, Word V));
extern void PLABELWR   P__((Word P));
extern Word PLDEG  P__((Word P));
extern Word PLPOS  P__((Word P, Word i));
extern void PQFF   P__((Word F, Word L, Word *Lp_));
extern void PRDADJINFO  P__((void));
extern void PRAPPROX  P__((void));
extern void PRCCS   P__((void));
extern void PRDC   P__((void));
extern void PRDCC   P__((void));
extern void PRDDESIRED   P__((void));
extern void PRDESIRED   P__((void));
extern void PRDF   P__((void));
extern void PRDFPCSTAT   P__((void));
extern void PRDIP   P__((void));
extern Word PRDLEN   P__((Word A));
extern void PRDLV   P__((void));
extern void PRDNQFF   P__((void));
extern void PRDPC   P__((void));
extern void PRDPCS   P__((void));
extern void PRDPF   P__((void));
extern void PRDPJ   P__((void));
extern void PRDQ   P__((void));
extern void PRDQFF   P__((void));
extern void PRDSEARCH   P__((void));
extern void PRDSET   P__((void));
extern void PRDTRACEA   P__((void));
extern void PRDTRACED   P__((void));
extern void PRDVL   P__((void));
extern void PREQNCONST   P__((void));
extern void PRESPFWR   P__((void));
extern void PRESPPWR   P__((void));
extern void PRFINISH   P__((void));
extern void PRGO   P__((void));
extern void PRHELP   P__((Word W));
extern void PRIGS   P__((void));
extern void PRIPFZT  P__((void));
extern void PRLDB   P__((void));
extern void PRMCC   P__((Word *t_));
extern void PRODWR   P__((Word v));
extern Word PROJ   P__((Word k, Word P_k));
extern Word PROJCO   P__((Word r, Word A));
extern void PROJECT   P__((Word r, Word A, Word *P_, Word *J_));
extern Word PROJHO   P__((Word r, Word A));
extern Word PROJLA   P__((Word r, Word A));
extern Word PROJMC   P__((Word r, Word A));
extern Word PROJMCEC P__((Word k, Word A));
extern void PROMPT   P__((void));
extern void PROPAGATE   P__((Word D, Word c, Word k, Word f, Word Q));
extern Word PROPCONS  P__((Word k, Word Q, Word F));
extern void PRPROJOP   P__((void));
extern void PRQUIT   P__((void));
extern void PRRMPF   P__((void));
extern void PRRMPJ   P__((void));
extern void PRRSP   P__((void));
extern void PRSEARCH  P__((void));
extern void PRSIMPLIFIER  P__((void));
extern void PRSTEP   P__((Word *t_));
extern void PRTCN   P__((void));
extern void PRTRACEA   P__((void));
extern void PRTRACED   P__((void));
extern void PRUDB   P__((void));
extern void PRUSEDESIRED   P__((void));
extern void PRWHATIS   P__((void));
extern void PSIGTBL   P__((Word c, Word f, Word T_t, Word T_f, 
			   Word *Tp_t_, Word *Tp_f_));
extern void PSIMREP   P__((Word r, Word P, Word *rs_, Word *Ps_));
extern void QEGLOBALS P__((void));
extern void QEPCAD   P__((Word Fs, Word *t_, 
			  Word *F_e_, Word *F_n_, Word *F_s_));
extern Word QFFFSOP   P__((Word H, Word P, Word f));
extern void QFFLPWR   P__((Word N, Word V, Word F));
extern void QFFLWR   P__((Word N, Word V, Word F));
extern void QFFRDR   P__((Word V, Word *F_, Word *t_));
extern Word QFFTEV   P__((Word F, Word c, Word k));
extern void QFFWR   P__((Word V, Word F));
extern void QFRDR   P__((Word *q_, Word *t_));
extern void QFWR   P__((Word q));
extern Word RCFAFC   P__((Word b));
extern Word REPLACE   P__((Word f, Word F, Word Fp));
extern void RLOPRDR   P__((Word *p_, Word *t_));
extern void RLOPWR   P__((Word p));
extern Word RMCAFS   P__((Word F));
extern Word RMCAON   P__((Word F));
extern Word RMCONS   P__((Word r, Word J));
extern Word RMLREOP   P__((Word F));
extern Word RMMPF   P__((Word P, Word k));
extern Word RMMPJ   P__((Word J, Word k));
extern Word RMNOTOP   P__((Word F));
extern Word RMNOTOPN   P__((Word F));
extern Word RUPFMRC P__((Word M1,Word D1,Word C1,Word M2,Word D2,Word C2));
extern Word RNFAF   P__((Word a));
extern void SALGF   P__((Word f, Word F, Word *G_, Word *H_));
extern void SAMPLEWR   P__((Word c));
extern Word SELPIMP   P__((Word m, Word V));
extern void SEPLAB  P__((Word k, Word C, Word *Cb_, Word *Ch_));
extern void SETUPSYS   P__((void));
extern Word SIGNB   P__((Word B, Word I));
extern Word SIGNL   P__((Word c, Word L));
extern void SIGNLWR   P__((Word x));
extern void SIGNP   P__((Word c, Word k, Word B, Word I, Word E, Word L));
extern void SIGNP1   P__((Word c, Word P1, Word I));
extern void SIGNPR   P__((Word c, Word k, Word B, Word I, Word E, Word s));
extern void SIGNWR   P__((Word s));
extern Word SIGSUB   P__((Word A, Word B));
extern void SIGTBL   P__((Word c, Word f, Word T_t, Word T_f, 
			  Word *Tp_t_, Word *Tp_f_));
extern Word SIMPLE   P__((Word s));
extern void SIMPLEQE P__((Word A, Word I, Word B, Word J,
                          Word *G_, Word *s_, Word *t_, Word *K_,
                          Word *a_, Word *b_, Word *T1_, Word *T2_));
extern Word SIMPLIFY   P__((Word T_t, Word T_f, Word F, Word P, Word f));
extern void SOLUTION   P__((Word D, Word F, Word P, Word f, 
			    Word *t_, Word *F_e_, Word *F_n_, Word *F_s_));
extern Word SOPFST   P__((Word T));
extern void SPFRPSFT  P__((Word P, Word c, Word k, Word *R_, Word *F_));
extern Word SSCOMP   P__((Word c1, Word c2));
extern void STATWR   P__((void));
extern Word STFSOP   P__((Word H));
extern Word SUBST   P__((Word k, Word M, Word b, Word B));
extern Word SUBSTR   P__((Word k, Word b, Word B));
extern Word SVPOWR   P__((Word A, Word G));
extern Word SVPROD   P__((Word A, Word B));
extern void TAB  P__((Word n));
extern void TCHILD   P__((Word c, Word *A1_, Word *A0_, Word *E1_, Word *E0_));
extern Word TICAD   P__((Word Q, Word F, Word f, Word P, Word A));
extern void TREPIMP   P__((Word rh, Word Vh));
extern void TREPROJ   P__((Word k, Word P_k));
extern void TRMODEWR   P__((Word M));
extern void TRPC   P__((Word c));
extern void TRPIMP   P__((Word v, Word T));
extern void TRPIMPTBL   P__((Word C, Word R, Word V));
extern void TRPROD   P__((Word v));
extern void TRUTHWR   P__((Word t));
extern void TRXPROJ   P__((Word Ths, Word k, Word P_k, Word J));
extern Word TYPEAF   P__((Word A));
extern Word TYPEQFF   P__((Word F));
extern void UDEQNCONST  P__((Word D));
extern void USERINT   P__((Word P, Word W));
extern void VLREADR   P__((Word *V_, Word *t_));
extern void VREADR   P__((Word *v_, Word *t_));
extern void VWRITE   P__((Word v));
extern void XREADR   P__((Word *L_, Word *t_));








/* -----------------------------------------------*/
/*             Basic constants                    */
/* -----------------------------------------------*/

/* Strict Relational Operators */
#define LTOP   1
#define EQOP   2
#define GTOP   4

/* Other Relational Operators */
#define GEOP   6
#define NEOP   5
#define LEOP   3
      
/* Other Extended Relational Operators */
#define CDOP   0
#define TAOP   7
  
/* Logical Operators */
#define ANDOP     11
#define OROP      12
#define NOTOP     13
#define RIGHTOP   14
#define LEFTOP    15
#define EQUIOP    16

/* Quantifiers */
#define UNIVER    20
#define EXIST     21

/* Truth values */
#define TRUE    1
#define FALSE   0
#define UNDET   2

/* Truth Determination Mechanisms */
#define BYPRP   1
#define BYTEV   0
#define BYEQC   2

/* Sign */
#define POSITIVE    1
#define ZERO        0
#define NEGATIVE   -1

/* Solution Flag */
#define EQU      1
#define INEQU    0
      
/* Return Flag */
#define OK      1
#define ERROR   0
      
/* Cell */
#define LEVEL      1     /* If you change this, update MCELL also. */
#define CHILD      2
#define ASSIGNED   3
#define TRUTH      4
#define SAMPLE     5
#define INDX       6
#define SIGNPF     7
#define HOWTV      8
#define DEGSUB     9
#define MULSUB     10
      
/* Partial Orderings */
#define HLORD      1
#define LLORD      2
#define GIORD      3
#define LIORD      4
#define SRORD      5
#define SNORD      6
#define TCORD      7
#define NCORD      8
#define GDORD      9
#define LDORD      10

/* Cell attribute IDs */
#define CALEVEL      -1
#define CADIMENSION  -2
#define CADEGREE     -3
#define CALCINDEX    -4
#define CAPARITY     -5

#define CAINDEX0     -1000  /* All the value below this is reserved for 
                               index(i). */


/* Polynomial attributes */
#define PO_POLY       1     /* If you change this, update MPOLY also. */
#define PO_LABEL      2
#define PO_PARENT     3
#define PO_TYPE       4
#define PO_STATUS     5

#define PO_RES        10
#define PO_DIS        11
#define PO_LCO        12
#define PO_TCO        13
#define PO_FAC        14

#define PO_REMOVE     0
#define PO_KEEP       1

#define PO_ECON       1
#define PO_OTHER      2

/* Resultant structure. */
#define RES_PO_1      4
#define RES_PO_2      6

/* Algorithm to use for resultant and discriminant computations. */
#define MODULAR       1
#define SUBRES        2


/* -----------------------------------------------------------------------*/
/*                              Macros                                    */
/* -----------------------------------------------------------------------*/ 
#define LBLINDEX(L)    THIRD(L)                       /* ??? */
#define LBLLEVEL(L)    SECOND(L)                      /* ??? */
#define MKLABEL(a,b,c)  LIST3(LFS(a),(b),(c))         /* ??? */
#define SIGINS(A,B)     USINT((A),(B))



/* -----------------------------------------------------------------------*/
/*                              Data-bases                                */
/* -----------------------------------------------------------------------*/ 
extern Word DBAFCSBM;      /* Database for AFCSBM */   
extern Word DBAFPNIP;      /* Database for AFPNIP */
extern Word DBAFUPGC;      /* Database for AFUPGC */
extern Word DBAFUPSFN;     /* Database for AFUPSFN */
extern Word DBFNDTS;       /* Database for FNDTS */
extern Word DBGETRP;       /* Database for GETRP */
extern Word DBMODCR;       /* Database for MODCR */
extern Word DBIPFAC;       /* Database for IPFAC */

extern Word DBTIME;        /* Atcuall computation begin time */
extern Word DBINFO;        /* Info of the item found */


/* ------------------------------------------------------------------------*/
/*                              Commmand                                   */
/* ------------------------------------------------------------------------*/
extern Word COMMANDS;     /* Holds Info about commands */
extern Word COMCLASS;     /* Holds command classifications and descriptions. */


/* ------------------------------------------------------------------------*/
/*                          Intermediate results                           */
/* ------------------------------------------------------------------------*/
extern Word GVVL;         /* Variable List */
extern Word GVF;          /* Input Formula */
extern Word GVQ;          /* Quantifier List */
extern Word GVQFF;        /* Quantifier-free formula part of the input */
extern Word GVNQFF;       /* Normalized quantifier-free formula part */
extern Word GVNIP;        /* Input Normalized Polynomials */
extern Word GVLV;         /* Current Level */
extern Word GVPF;         /* Projection Factors */
extern Word GVPJ;         /* Projection Polynomials */
extern Word GVPC;         /* Current Partial CAD */
extern Word GVNV;         /* Number of variables */
extern Word GVNFV;        /* Number of Free Variables */
extern Word GVMCOMM;      /* Main comment */
extern Word GVEQNCONST;   /* Equational constraint list */
extern Word GVPIVOT;      /* Pivot equational constraint */


/* ------------------------------------------------------------------------*/
/*                    Algorithm  trace control                             */
/* ------------------------------------------------------------------------*/
extern Word TCPROJ;   /* Projection Operation */
extern Word TCIPLFAC; /* Complete Factorization */

/* ------------------------------------------------------------------------*/
/*                    Data trace control                                   */
/* ------------------------------------------------------------------------*/
extern Word TCPC;      /* Partial CAD */
extern Word TCPROD;    /* Product generated */
extern Word TCPIMP;    /* Prime Implicant */
extern Word TCPIMPTBL; /* Prime Implicant Table */
extern Word TCEPIMP;   /* Essential Prime Implicant */ 
extern Word TCSTAT;    /* Statistics at the end */
extern Word TCDSTAT;   /* Dissertation statistics at the end */


/* ------------------------------------------------------------------------*/
/*                       Program control                                   */
/* ------------------------------------------------------------------------*/
extern Word PCNSTEP;     /* Number of steps to be skipped */
extern Word PCFINISH;    /* 'y' if finish, 'n' otherwise */
extern Word PCMC;        /* 'y' if a cell is  chosen manually, 
			  * 'n' otherwise */
extern Word PCMCC;       /* The cell manually chosen */
extern Word PCTCN;       /* 'y' if trivial conversion is treated, 
			  * 'n' otherwise */
extern Word PCRSP;       /* 'y' if rational sample point is treated, 
			  * 'n' otherwise */
extern Word PCFULL;      /* 'y' if a full CAD is to be build */
extern Word PCDBUSE;     /* 'y' if Databases are used 'n' otherwise */
extern Word PCDBLIMIT;   /* Limit for Database Entry */
extern Word PCPROJOP;    /* Projection operators */       
extern Word PCCCS;       /* Cell Choice Strategy for cells of level >= f. */
extern Word PCCCSF;      /* Cell Choice Strategy for cells of level < f. */
extern Word PCIGS;       /* Implicant Generation Strategy */
extern Word PCDESIRED;   /* Desired cell condition */
extern Word PCUSEDES;    /* 'y' if use the desired condition, 'n' otherwise. */
extern Word PCIPFZT;     /* 'y' if IPFZT is turned on, 'n' otherise. */
extern Word PCNUMDEC;    /* Number of decimal digits for 
			  * approximating algebraic numbers. */
extern Word PCSIMPLIFY;  /* 'b' if bottom-up is used.   
			  * 't' if top-down is used. */
extern Word PCEQC;       /* 1 if equational contraint specified.
			  * 0 otherwise. */
extern Word PCRESALG;    /* Choice of resultant algorithm. */
extern Word PCPROPEC;    /* Propagation of equational constraints. */

extern Word PCSEARCHOK;     /* 'y' if the search for true/false cell succeeded, 'n' otherwise. */
extern Word PCSEARCHTRUE;   /* 'y' if the search for true cell should be done, 'n' otherwise. */
extern Word PCSEARCHFALSE;  /* 'y' if the search for false cell should be done, 'n' otherwise. */


/* ------------------------------------------------------------------------*/
/*                              Statistics                                 */
/* ------------------------------------------------------------------------*/
#define MNV    30  /* Maximum Number of Variables = 30 */
#define MNV1   31  /* One more for C arrary. */

/* Statictics on QEPCAD */
extern Word BTMQEPCAD;     /* Time at which QECAD was called */

/* Statistics on Normalization Phase */
extern Word TMNORMQFF;     /* Time for Normalization Phase, NORMQFF */

/* Statistics on Projection Phase */
extern Word TMPROJECT[MNV1];   /* Time for Projection Phase, PROJECT */
extern Word   TMPROJ[MNV1];       /* Time for Projection Operation,  PROJ */
extern Word     TMIPFZT[MNV1];      /* Time for Finite Zero Test, IPFZT */
extern Word   TMIPLFAC[MNV1];     /* Time for Complete Factorization, IPLFAC */
extern Word   TMAPPEND[MNV1];     /* Time for Appending, APPEND */

/* Statistics on Truth Invariant CAD Construction Phase */
extern Word TMTICAD[MNV1];     /* Time for Truth invariant CAD Construnction Phase, TICAD */
extern Word   TMCHOOSE[MNV1];    /* Time for Choosing a cell, CHOOSE */
extern Word   TMCONVERT[MNV1];   /* Time for Conversion, CONVERT */
extern Word     TMTCN[MNV1];       /* Time for Trivial Conversion */
extern Word     TMNORMAL[MNV1];    /* Time for NORMAL, NORMAL */
extern Word     TMSIMPLE[MNV1];    /* Time for SIMPLE, SIMPLE */
extern Word   TMCONSTRUCT[MNV1]; /* Time for stack construction, CONSTRUCT */
extern Word     TMSUBST[MNV1];     /* Time for substituting on irrational sample point, SUBST */
extern Word     TMAFUPLM[MNV1];    /* Time for computing ldcf and monic associates, AFUPLM */
extern Word     TMAFCSBM[MNV1];    /* Time for computing coarsest squarefree basis, AFCSBM */
extern Word     TMAFPBRI[MNV1];    /* Time for isolating real roots of algebraic polys, AFUPBRI */
extern Word     TMEC[MNV1];        /* Time for establishing children on irration, EC */
extern Word     TMSIGNP[MNV1];     /* Time for computing projection signatures, SIGNP */
extern Word     TMRCFAFC[MNV1];    /* Time for converting to rational polynomials, RCFAFC */
extern Word     TMSUBSTR[MNV1];    /* Time for substituting on rational sample point, SUBSTR */
extern Word     TMIPLSRP[MNV1];    /* Time for computing signs and similar int; polys, IPLSRP */
extern Word     TMIPFSBM[MNV1];    /* Time for computing finest squarefree basis, IPFSBM */
extern Word     TMIPLRRI[MNV1];    /* Time for integral poly real root isolation,  IPLRRI */
extern Word     TMECR[MNV1];       /* Time for establishing children on rational, ECR, EC1 */
extern Word     TMSIGNPR[MNV1];    /* Time for computing projection signature, SIGNPR, SIGNP1 */  
extern Word   TMEVALUATE[MNV1];  /* Time for trial evaluataion, EVALUATE */
extern Word   TMPROPAGATE[MNV1]; /* Time for propagation, PROPAGATE */
extern Word   TMAPEQC[MNV1];  /* Time to apply equational constraints, APEQC */

/* Statistics on Solution Formula Construction Phase */
extern Word TMSOLUTION;      /* Time for Solution Formula Construction Phase */
extern Word   TMSIGTBL;        /* Time for building signature tables, SIGTBL */
extern Word   TMSIGINS;        /* Time for computing the signature intersection, SIGINS */
extern Word   TMMVLMASF;       /* Time for MVLMA, MVLMASF */
extern Word     TMGENIMP;        /* Time for generating implicants, GENIMP */
extern Word     TMSELIMP;        /* Time for selecting implicants, SELIMP */

/* Statatics, Counting */
extern Word NMNIP[MNV1];      /* Number of normalized input polynomials */
extern Word NMPF[MNV1];       /* Number of projection factors */
extern Word NMPJ[MNV1];       /* Number of projection polynomials */
extern Word NMSTACK[MNV1];    /* Number of Stacks */
extern Word NMSTACKR[MNV1];   /* Number of Stack over a Rational sample poWord */
extern Word NMCELL[MNV1];     /* Number of Cells */
extern Word NMCONVERT[MNV1];  /* Number of Conversion */
extern Word NMTCONVERT[MNV1]; /* Number of Trivial Conversion */
extern Word NMFPF;            /* Number of Projection factors of level <= f */
extern Word NMPRPT;           /* Number of propgation solution signatures */
extern Word NMPRPF;           /* Number of propagation non-solution signatures */
extern Word NMPRPC;           /* Number of compatible propagation signatures */
extern Word NMGENPRD;         /* Number of products generated */
extern Word NMGENIMP;         /* Number of implicants generated */
extern Word NMSELIMP;         /* Number of implicants selected */
extern Word NMATOM;           /* Number of atomic formulas in the solution qff */

/* Statistics on Databases */
extern Word TMDBMNG;     /* Time for Database management */
extern Word TMDBSAV;     /* Time Saved by using databases */


/* ------------------------------------------------------------------------*/
/*                    Input and output                                     */
/* ------------------------------------------------------------------------*/
#define ISIZE  70
extern char IBUFF[ISIZE];    /* The size of input buffer for errory display. */
extern Word IPOS;            /* The position of the last character read. */
extern Word OPOS;            /* The position of the last character written. */
extern Word ECHO;            /* Echo the input if 1. */
extern Word WASBKSP;         /* 1 if there was backspace. */
extern FILE *INSTREAM;       /* Input stream. */
extern FILE *OUTSTREAM;      /* Output stream. */
/* -------------------------------------------------------------------------*/
#endif
