/*======================================================================
                      t <- CAPTURE(P,M)

Capture?

\Input
  \parm{P} is a product.
  \parm{M} is a minterm.
  
\Output
  \parm{t} is 1 if $P$ captures $M$, 0 otherwise.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word CAPTURE(P,M)
       Word P,M;
{
       Word M1,Mp,P1,Pp,t;
       /* hide t; */

Step1: /* Determine. */
       Pp = P; Mp = M;
       while (Pp != NIL)
         {
         ADV(Pp,&P1,&Pp); ADV(Mp,&M1,&Mp);
         switch (P1)
           {
           case TAOP: break;
           case GEOP: if (M1 == LTOP) { t = 0; goto Return; } break;
           case LEOP: if (M1 == GTOP) { t = 0; goto Return; } break;
           case NEOP: if (M1 == EQOP) { t = 0; goto Return; } break;
           case GTOP: if (M1 != GTOP) { t = 0; goto Return; } break;
           case LTOP: if (M1 != LTOP) { t = 0; goto Return; } break;
           case EQOP: if (M1 != EQOP) { t = 0; goto Return; }
           break; }
         }
       t = 1; goto Return;

Return: /* Prepare for return. */
       return(t);
}
