/*======================================================================
                      H <- ESPRESSO(T_t,T_f)

Espresso.

\Input
  \parm{Tt} is the signature table for the TRUE-set of a logic function.
  \parm{Tf} is the signature table for the FALSE-set of the logic function.

\Output
  \parm{H} is a simple cover for the logic function.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#include <stdio.h>
#include <strings.h>

Word ESPRESSO(T_t,T_f)
       Word T_t,T_f;
{
       Word H,e;
       char *filename;
       char in[1000];   /* Should be enough! */
       char com[1000];  /* Should be enough! */
       char out[1000];  /* Should be enough! */
       FILE *s;

Step1: /* Generate file names. */
       filename = tmpnam(NULL);
       strcpy(in,filename);
       strcat(in,".in");
       strcpy(out,filename);
       strcat(out,".out");

Step2: /* Write the input of Espresso. */
       fflush(OUTSTREAM);
       s = OUTSTREAM;
       OUTSTREAM = fopen(in,"w");
       ESPIWR(T_t,T_f);
       fclose(OUTSTREAM);
       OUTSTREAM = s;

Step3: /* Execute Espresso. */
       strcpy(com,"mvlma ");
       strcat(com," < ");
       strcat(com,in);
       strcat(com," > ");
       strcat(com,out);
       system(com);

Step4: /* Read the output of Espresso. */
       s = INSTREAM;
       e = ECHO;
       ECHO = 0;
       INSTREAM = fopen(out,"r");
       H = ESPORD();
       fclose(INSTREAM);
       INSTREAM = s;
       ECHO = e;

Step5: /* Delete the temporary files. */
       strcpy(com,"rm -f ");
       strcat(com,in);
       strcat(com," ");
       strcat(com,out);
       system(com);

Return: /* Prepare for return. */
       return(H);
}
