/*======================================================================
                      NEXTCOMB(n,r,Rs; R,q)

Next combination.

\Input
  \parm{n} is the total number of the elements.
  \parm{r} is the number of elements to be chosen.
  \parm{R*} is a combination.

\Output
  \parm{R} is the next combination if successful.
  \parm{q} is 1 if successful, 0 otherwise.

\Side
  \parm{R*} is modified.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void NEXTCOMB(n,r,Rs, R_,q_)
       Word n,r,Rs, *R_,*q_;
{
       Word R,R1,Rp,k,q;
       /* hide k,q; */

Step1: /* Determine the last updatable digit. */
       R = Rs;
       R = INV(R);
       Rp = R;
       k = n;
       while (Rp != NIL)
         {
         R1 = FIRST(Rp);
         if (R1 < k) goto Step2;
         Rp = RED(Rp);
         k = k - 1;
         }
       q = 0; goto Return;

Step2: /* Update. */
       R = INV(R);
       SFIRST(Rp,R1 + 1);
       Rp = RED(Rp);
       R1 = R1 + 2;
       while (Rp != NIL)
         {
         SFIRST(Rp,R1);
         Rp = RED(Rp);
         R1 = R1 + 1;
         }
       q = 1; goto Return;

Return: /* Prepare for return. */
       *R_ = R;
       *q_ = q;
       return;
}
