/*======================================================================
                      H <- NQFFAND(F,G)

Normalized Quantifier Free Formula And.

\Input
  \parm{F} is a normalized quantifier-free formula.
  \parm{G} is a normalized quantifier-free formula.

\Output
  \parm{H} is the normalized quantifier-free formula
           such that $H = F \land G$.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word NQFFAND(F,G)
       Word F,G;
{
       Word H;

Step1: /* Compute. */
       if (TYPEQFF(F) == FALSE) H = LIST4(NEOP,0,0,NIL);
       else if (TYPEQFF(G) == FALSE) H = LIST4(NEOP,0,0,NIL);
       else if (TYPEQFF(F) == TRUE) H = G;
       else if (TYPEQFF(G) == TRUE) H = F;
       else H = LIST3(ANDOP,F,G);
       goto Return;

Return: /* Prepare for return. */
       return(H);
}
