                 SOLUTION(D,F,P,f;t,Fe,Fn,Fs)
 
[Solution Formula Construction Phase.
 
\Input
  \parm{D} is a truth--invariant partial CAD.
  \parm{F} is the normalized quantifier-free  part of the input formula.
  \parm{P} is the list~$(P_1,\ldots,P_r)$, 
           where $P_i$ is the list of
           the $i$--level projection factors.
  \parm{f} is the number of free variables in the input formula.
 
\Output
  \parm{t}  is either \cn{equ} or \cn{inequ}.
  \parm{Fe} is a quantifier-free formula equivalent to
            the input formula if  $t$ is \cn{equ},
            otherwise $F_e$ is undefined.
  \parm{Fn} is a quantifier-free formula necessary for
            the input formula if $t$ is \cn{inequ},
            otherwise $F_n$ is undefined.
  \parm{Fs} is a quantifier-free formula sufficient for
            the input formula if $t$ is \cn{inequ},
            otherwise $F_s$ is undefined.
]
  
include "qepcadGlobals.h"
           
(1) [Decision Problem.]
    if f > 0 then  goto 2;
    t := EQU;
    if LELT(D,TRUTH) = TRUE then
      Fe := LIST4(EQOP,0,0,())
    else
      Fe := LIST4(NEOP,0,0,());
    return.
 
(2) [Signature tables.]  
    SIGTBL(D,(),f,(),();Tt,Tf); 
    Tt := INV(Tt); Tt := RMSAME(Tt); 
    Tf := INV(Tf); Tf := RMSAME(Tf).

(3) [Any indistinguishable cell?]
    Tc := SIGINS(Tt,Tf);
    if Tc = () then
       t := EQU
    else
      {t := INEQU; goto 5}.
            
(4) [$F_e$.]
    Fe := SIMPLIFY(Tt,Tf,F,P,f);
    return.
    
(5) [$F_n$.]
    Fn := SIMPLIFY(Tt,SIGSUB(Tf,Tc),F,P,f).
            
(6) [$F_s$.]
    Fs := SIMPLIFY(SIGSUB(Tt,Tc),Tf,F,P,f);
    return ||
