/*======================================================================
                      H <- SOPFST(T)

Sum-Of-Product From Signature Table.

\Input
  \parm{T} is a list of distinct signatures.
  
\Output
  \parm{H} is a sum-of-product corresponding to $T$.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word SOPFST(T)
       Word T;
{
       Word H,H1,T1,T11,Tp;

Step1: /* Convert. */
       H = NIL;
       Tp = T;
       while (Tp != NIL)
         {
         ADV(Tp,&T1,&Tp);
         H1 = NIL;
         while (T1 != NIL)
           {
           ADV(T1,&T11,&T1);
           switch (T11)
             {
             case POSITIVE: H1 = COMP(GTOP,H1); break;
             case ZERO: H1 = COMP(EQOP,H1); break;
             case NEGATIVE: H1 = COMP(LTOP,H1); break;
             case UNDET: H1 = COMP(TAOP,H1);
             break; }
           }
         H1 = INV(H1);
         H = COMP(H1,H);
         }
       H = INV(H);
       goto Return;

Return: /* Prepare for return. */
       return(H);
}
