/*======================================================================
                      S <- SUBSTR(k,b,B)

Substitute the rational sample point into the projection factors.

\Input
  \parm{k} is a positive $\beta$--integer.
  \parm{b} is the $k$-tuple coordinates of a rational sample point.
  \parm{B} is a list~$(B_1,\ldots,B_m)$ of 
           $(k+1)$--variate integral polynomials.

\Output
  \parm{S} is the list~$(S_1,\ldots,,S_m)
            where $S_i = B_i(b_1,\ldots,b_k,x_{k+1})$.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word SUBSTR(k,b,B)
       Word k,b,B;
{
       Word B1,Bp,S,S1;

Step1: /* Do it. */
        S = NIL;
        Bp = B;
        while (Bp != NIL)
           {
           ADV(Bp,&B1,&Bp);
           S1 = IPRNME(k + 1,B1,b);
           S = COMP(S1,S);
           }
        S = INV(S);
        goto Return;

Return: /* Prepare for return. */
       return(S);
}
